import re


class Token:
    """A token generated by the lexer."""

    name: str
    regex: str
    body: str
    _match: re.Match
    position: tuple[int, int]

    def __repr__(self):
        return f"<{self.name!r}>"

    def __init__(self, match: re.Match, position: tuple[int, int]) -> None:
        self.body = match.group(0)
        self.position = position
        self._match = match
